Makefile.am 10.1 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13 14 15 16
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
17
httpdir = $(pkgpythondir)/http
Guido Trotter's avatar
Guido Trotter committed
18
confddir = $(pkgpythondir)/confd
19
rapidir = $(pkgpythondir)/rapi
20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
Guido Trotter's avatar
Guido Trotter committed
29
	doc/examples/hooks \
30
	lib \
31
	lib/http \
32
	lib/hypervisor \
33
	lib/rapi \
Guido Trotter's avatar
Guido Trotter committed
34
	lib/confd \
35 36 37 38 39 40 41
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
42
MAINTAINERCLEANFILES = \
43
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
44 45
	$(maninput)

46 47 48
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

49 50 51
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
52
	doc/examples/bash_completion \
53 54 55
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
56
	lib/http/*.py[co] \
57
	lib/hypervisor/*.py[co] \
58
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
59 60
	$(man_MANS) \
	$(manhtml) \
61 62 63 64 65 66 67 68 69 70
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
71
	lib/asyncnotifier.py \
72 73 74 75 76 77 78
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
79
	lib/daemon.py \
80 81
	lib/errors.py \
	lib/jqueue.py \
82
	lib/jstore.py \
83 84 85 86 87 88 89 90 91
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
92
	lib/storage.py \
93 94
	lib/utils.py \
	lib/workerpool.py
95 96 97 98

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
99
	lib/hypervisor/hv_chroot.py \
100
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
101
	lib/hypervisor/hv_kvm.py \
102 103
	lib/hypervisor/hv_xen.py

104 105
rapi_PYTHON = \
	lib/rapi/__init__.py \
106 107 108
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
109

110
http_PYTHON = \
111
	lib/http/__init__.py \
112
	lib/http/auth.py \
113 114
	lib/http/client.py \
	lib/http/server.py
115

Guido Trotter's avatar
Guido Trotter committed
116
confd_PYTHON = \
Guido Trotter's avatar
Guido Trotter committed
117
	lib/confd/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
118 119
	lib/confd/server.py \
	lib/confd/querylib.py
120

Michael Hanselmann's avatar
Michael Hanselmann committed
121
docrst = \
122
	doc/admin.rst \
123
	doc/design-2.0.rst \
124
	doc/design-2.1.rst \
125
	doc/glossary.rst \
126
	doc/hooks.rst \
127
	doc/iallocator.rst \
128
	doc/index.rst \
129
	doc/install.rst \
130
	doc/rapi.rst \
131
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
132

133 134 135 136 137 138 139 140 141 142
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
143

144 145 146
docdot = \
	doc/arch-2.0.dot

147
docpng = $(patsubst %.dot,%.png,$(docdot))
148

149
noinst_DATA = $(manhtml) doc/html
150

151 152 153 154
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
Guido Trotter's avatar
Guido Trotter committed
155
	daemons/ganeti-confd \
156
	daemons/ganeti-rapi \
157 158 159 160 161 162 163 164 165 166 167 168 169 170 171
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
172
	$(MAINTAINERCLEANFILES) \
173 174
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
175
	pylintrc \
176 177
	autotools/docbook-wrapper \
	devel/upload.in \
178
	$(docdot) \
179 180 181
	$(docrst) \
	doc/conf.py \
	doc/html \
182
	doc/examples/bash_completion.in \
183 184 185
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
Guido Trotter's avatar
Guido Trotter committed
186
	doc/examples/hooks/ethers \
187
	doc/locking.txt \
188 189 190 191 192
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
193
	$(mansgml) $(maninput) \
194
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
195
	qa/qa-sample.json \
196 197 198 199 200 201 202 203
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
204
	qa/qa_rapi.py \
205 206 207 208 209
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
210
	man/ganeti-masterd.8 \
211 212
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
213
	man/ganeti-rapi.8 \
214 215 216
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
217
	man/gnt-debug.8 \
218
	man/gnt-instance.8 \
219
	man/gnt-job.8 \
220 221 222
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
223 224 225
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
226 227 228

TEST_FILES = \
	test/data/bdev-both.txt \
229
	test/data/bdev-8.3-both.txt \
230 231
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
232 233
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
234 235

dist_TESTS = \
236 237 238
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
239
	test/ganeti.config_unittest.py \
240
	test/ganeti.constants_unittest.py \
241
	test/ganeti.hooks_unittest.py \
242
	test/ganeti.http_unittest.py \
243
	test/ganeti.locking_unittest.py \
244
	test/ganeti.objects_unittest.py \
245
	test/ganeti.rapi.resources_unittest.py \
246 247 248 249
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
250 251 252 253 254

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

255
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
256

257
all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
258
	doc/examples/bash_completion \
259 260 261 262 263 264
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
265
doc/examples/%: doc/examples/%.in stamp-directories \
266 267 268
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

269
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
270
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
271 272
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
273
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
274
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
275 276 277 278 279 280 281
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
282
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
283 284 285 286 287 288 289 290
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
291

Iustin Pop's avatar
Iustin Pop committed
292 293
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
294

Iustin Pop's avatar
Iustin Pop committed
295 296
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
297

298 299
man/footer.sgml $(TESTS): srclinks

300
$(TESTS): ganeti lib/_autoconf.py
301 302 303 304 305

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
306 307 308 309 310 311 312 313 314
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
315 316 317 318 319 320 321 322 323 324 325 326 327 328 329
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
330
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
331
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
332
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
333
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
334 335 336 337 338 339 340 341 342 343 344
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
345
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
Iustin Pop's avatar
Iustin Pop committed
346
	  echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
347 348 349 350 351 352 353
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
354
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
Guido Trotter's avatar
Guido Trotter committed
355
			$(rapi_PYTHON) $(http_PYTHON) $(confd_PYTHON); do \
356 357 358 359
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
360

Michael Hanselmann's avatar
Michael Hanselmann committed
361 362
.PHONY: ganeti
ganeti:
363
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
364

Iustin Pop's avatar
Iustin Pop committed
365 366 367 368 369 370 371
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
372
install-exec-local:
373
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
374 375
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
376 377 378 379 380

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
381 382 383
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
384
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
385 386
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
387
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
388 389
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
390
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
391 392 393 394
		) ; \
		rm -rf $$TMPDIR ; \
	}

395 396 397 398 399 400 401
.PHONY: TAGS
TAGS:
	rm -f TAGS
	find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
	  -path 'daemons/ganeti-*' -o -path 'tools/*' | \
	  etags -

402
# vim: set noet :